// Create and call machine program code
//  2004 Jakub Sika. All rights reserved.
//

/////////////////////////////////////////////////////////////////
// @desc
// 
// Demonstrates creation and calling of machine instruction code.

// @tbl
// std Standard

/////////////////////////////////////////////////////////////////
//	Correspondent Windows API call:
//	MessageBeep(-1);

//	; Machine code
//	push	ebp
//	mov		ebp, esp
//	sub		esp, 4
//	mov		dword ptr [ebp-4], pMsgProc
//	push	0ffh
//	call	dword ptr [ebp-4]
//	;add	sp, 4
//	mov		esp, ebp
//	pop		ebp
//	ret

/////////////////////////////////////////////////////////////////
// Program entry point
// @std
//
Main()
{
	pAsmProc = MemAlloc(26);
	pMsgProc = GetProc(VarGetInt("User32"), "MessageBeep");

	if (!pMsgProc)
	{
		Msg("Error - procedure not found");
		return -1;
	}

	// ---------------------------
	// 55		push	ebp
	MemSetByte(pAsmProc, 85);

	// 8B EC	mov		ebp, esp
	MemSetByte(pAsmProc + 1, 139);
	MemSetByte(pAsmProc + 2, 236);

	// 81 EC 04 00 00 00
	//		sub		esp, 4
	MemSetByte(pAsmProc + 3, 129);
	MemSetByte(pAsmProc + 4, 236);
	MemSet(pAsmProc + 5, 4);

	// C7 45 FC [pMsgProc]
	//		mov		dword ptr [ebp-4], pMsgProc
	MemSetByte(pAsmProc + 9, 199);
	MemSetByte(pAsmProc + 10, 69);
	MemSetByte(pAsmProc + 11, 252);
	MemSet(pAsmProc + 12, pMsgProc);

	// 6A FF	push	0ffh
	MemSetByte(pAsmProc + 16, 106);
	MemSetByte(pAsmProc + 17, 255);

	// FF 55 FC 
	//		call	dword ptr [ebp-4]
	MemSetByte(pAsmProc + 18, 255);
	MemSetByte(pAsmProc + 19, 85);
	MemSetByte(pAsmProc + 20, 252);

	// 83 C4 04	Not used
	//		add		sp, 4
	/*MemSetByte(pAsmProc + 21, 131);
	MemSetByte(pAsmProc + 22, 196);
	MemSetByte(pAsmProc + 23, 4);*/

	// 8B E5	mov		esp, ebp
	MemSetByte(pAsmProc + 21, 139);
	MemSetByte(pAsmProc + 22, 229);

	// 5D		pop		ebp
	MemSetByte(pAsmProc + 23, 93);

	// C3		ret
	MemSetByte(pAsmProc + 24, 195);
	// ---------------------------

	CallProc(pAsmProc);
	MemFree(pAsmProc);

	return 0;
}
