// Folder selection routine
//  2004 Jakub Sika. All rights reserved.
//

/////////////////////////////////////////////////////////////////
// @desc
// 
// Demonstrates folder selection Windows API function SHBrowseForFolder().

// @tbl
// std Standard

/////////////////////////////////////////////////////////////////
// Program entry point
// @std
//
Main()
{
	strResult = BrowseFolder("Please select your destination:");
	return strResult;
}

/////////////////////////////////////////////////////////////////
// Browser folder routine
// @std
//		strTitle: message that appears in the dialog
// Return: path of the folder selected
//		"" - no selection (canceled)
//
BrowseFolder(strTitle)
{
	hLib = LoadLib("Shell32");
	pInfo = MemAlloc(64);
	pszPath = MemAlloc(260);
	pszTitle = MemAlloc(260);
	MemSet(pszTitle, strTitle);
	MemSet(pInfo, VarGetInt("HWND"));	// Use main window handle as a parent
	MemSet(pInfo + 12, pszTitle);
	MemSet(pInfo + 16, 1);			// BIF_RETURNONLYFSDIRS flag set
	iId = CallProc("SHBrowseForFolder", hLib, pInfo);
	strResult = "";

	if (iId)
	{
		if (CallProc("SHGetPathFromIDList", hLib, iId, pszPath))
			strResult = MemGetStr(pszPath);
	}

	MemFree(pszTitle);
	MemFree(pszPath);
	MemFree(pInfo);
	FreeLib(hLib);

	return strResult;
}
