// EnumFonts callback example
//  2004 Jakub Sika. All rights reserved.
//

/////////////////////////////////////////////////////////////////
// @desc
// 
// Demonstrates fonts enumeration using callback function.

// @tbl
// std Standard

g_iMaxLen = 1024;

/////////////////////////////////////////////////////////////////
// Program entry point
// @std
//
Main()
{
	pszFontList = MemAlloc(2048, "");
	hDC = CallProc("CreateDCA", "Gdi32.dll", "DISPLAY", 0, 0, 0);
	pEnumFontsProc = CreateProc("EnumFontsProc", "i4i4i4i4");
	iRet = CallProc("EnumFontsA", "Gdi32.dll", hDC, 0, pEnumFontsProc, pszFontList);
	DeleteProc(pEnumFontsProc);
	CallProc("DeleteDC", "Gdi32.dll", hDC);
	CallProc("MessageBoxA", "User32.dll", VarGetInt("hWnd"), pszFontList, "Font List", 64);
	MemFree(pszFontList);

	return iRet;
}

/////////////////////////////////////////////////////////////////
// Font enumerator callback
// @std
//		pLogFont: pointer to LOGFONT structure
//		pTextMetric: pointer to TEXTMETRIC structure
//		iType: font type (1 - raster, 2 - device, 4 - TrueType)
//		pParam: parameter supplied by EnumFonts call
// Return: non-zero - continue enumeration, 0 - stop
//
// This function is called by the system for every font.
// To obtain necessary information, access appropriate member of the Windows API structures.
//
EnumFontsProc()
{
	pArray = VarGetInt("ProcParams");
	pLogFont = ArrGetInt(pArray, 0);
	pszFontList = ArrGetInt(pArray, 3);
	iLength = StrLen(pszFontList);
	pszFontFace = MemGetStr(pLogFont + 28);
	MemSet(pszFontList + StrLen(pszFontList), StrFormat("%s\n", pszFontFace));

	if (StrLen(pszFontList) > g_iMaxLen)
	{
		// Buffer top was overlappped, cut it and stop enumeration
		MemSetByte(pszFontList + iLength, 0);
		return 0;
	}

	return 1;
}
