// GetVersion example
//  2004 Jakub Sika. All rights reserved.
//

/////////////////////////////////////////////////////////////////
// @desc
// 
// Demonstrates using GetVersionEx windows API function to obtain system version information.

// @tbl
// std Standard

/////////////////////////////////////////////////////////////////
// Program entry point
// @std
//
Main()
{
	pOSV = MemAlloc(148);	
	MemSet(pOSV, 148);

	if (!CallProc("GetVersionExA", VarGetInt("Kernel32"), pOSV))
	{
		MemFree(pOSV);
		Msg("Error");

		return 0;
	}

	switch (MemGetInt(pOSV + 16))
	{
	case 0:
		strPlatform = "Win32s";
		break;
	case 1:
		strPlatform = "Windows";
		break;
	case 2:
		strPlatform = "Windows NT";
		break;
	default:
		strPlatform = "<unknown>";
	}

	strVersion = StrFormat("Version %ld.%ld, Build %ld, Platform %s", 
		MemGetInt(pOSV + 4), MemGetInt(pOSV + 8), 
		MemGetInt(pOSV + 12) & 0xFFFF, strPlatform);
	MemFree(pOSV);

	return strVersion;
}
