// Translate2RTF example
//  2004 Jakub Sika. All rights reserved.
//

/////////////////////////////////////////////////////////////////
// @desc
// 
// Demonstrates translating plain text to RTF.
// Characters, that normally affect Richtext formatting are replaced to display them correctly.

// @tbl
// std Standard

/////////////////////////////////////////////////////////////////
// Program entry point
// @std
//
Main()
{
	Msg(Translate2RTF("...text #1 {\\plain\\b\\cf0 text #2} text #3  2004"));
}

/////////////////////////////////////////////////////////////////
// Translate special characters
// @std
// 		strText: plain text to translate
// Return: rich text compatible text
//
// Translate subsequent characters:
// 		\	->	\\
// 		#	->	##
// 		{	->	\{
// 		}	->	\}
// 			->	\'a9
//
Translate2RTF(strText)
{
	strResult = strText;

	for (iIndex = 0, iSize = StrLen(strResult); iIndex < iSize; iIndex++)
	{
		if (SubStr(strResult, iIndex, 1) == "\\")
		{
			if (iIndex)
				strResult = SubStr(strResult, 0, iIndex) + "\\\\" + SubStr(strResult, iIndex + 1, 0);
			else
				strResult = "\\\\" + SubStr(strResult, iIndex + 1, 0);

			iIndex++;
			iSize++;
		}
		else if (SubStr(strResult, iIndex, 1) == "#")
		{
			if (iIndex)
				strResult = SubStr(strResult, 0, iIndex) + "##" + SubStr(strResult, iIndex + 1, 0);
			else
				strResult = "##" + SubStr(strResult, iIndex + 1, 0);

			iIndex++;
			iSize++;
		}
		else if (SubStr(strResult, iIndex, 1) == "{")
		{
			if (iIndex)
				strResult = SubStr(strResult, 0, iIndex) + "\\{" + SubStr(strResult, iIndex + 1, 0);
			else
				strResult = "\\{" + SubStr(strResult, iIndex + 1, 0);

			iIndex++;
			iSize++;
		}
		else if (SubStr(strResult, iIndex, 1) == "}")
		{
			if (iIndex)
				strResult = SubStr(strResult, 0, iIndex) + "\\}" + SubStr(strResult, iIndex + 1, 0);
			else
				strResult = "\\}" + SubStr(strResult, iIndex + 1, 0);

			iIndex++;
			iSize++;
		}
		else if (SubStr(strResult, iIndex, 1) == "")
		{
			if (iIndex)
				strResult = SubStr(strResult, 0, iIndex) + "\\'a9" + SubStr(strResult, iIndex + 1, 0);
			else
				strResult = "\\'a9" + SubStr(strResult, iIndex + 1, 0);

			iIndex += 3;
			iSize += 3;
		}
	}

	return strResult;
}
