// Main.cpp module for HMod
//  2004 Jakub Sika. All rights reserved.
//

#include <Windows.h>
#include "HyperScript.h"

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		MessageBox(0, "Initializing module...", "", MB_OK);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		MessageBox(0, "Deinitializing module...", "", MB_OK);
	}

	return TRUE;
}

static void Routine1(PLC_DATATYPE *Parms, sdword ParmTotal)
{
	char szResult[PLC_DT_STRING_MAX];

	if (ParmTotal != 0)
	{
		wsprintf(szResult, "Routine1(): incorrect number of parameters at line %i.", PLC_GetSourceLine());
		PLC_Error(0, szResult);

		return;
	}

	wsprintf(szResult, "...return from Routine1");
	PLC_DT_Init(PLC_DT_GetResult(), PLC_DT_STRING);
	PLC_DT_SetString(PLC_DT_GetResult(), szResult);
}

static void Routine2(PLC_DATATYPE *Parms, sdword ParmTotal)
{
	char szResult[PLC_DT_STRING_MAX];

	if (ParmTotal != 2)
	{
		wsprintf(szResult, "Routine2(a, b): incorrect number of parameters at line %i.", PLC_GetSourceLine());
		PLC_Error(0, szResult);

		return;
	}

	wsprintf(szResult, "Routine2: %ld * %ld = %ld...", 
		PLC_DT_GetInt(&Parms[0]), PLC_DT_GetInt(&Parms[1]), 
		PLC_DT_GetInt(&Parms[0]) * PLC_DT_GetInt(&Parms[1]));
	PLC_Message(0, szResult);
}

bool PLC_R_InitModule()
{
	PLC_AddCommand("Routine1", (void (__cdecl *)(struct PLC_DATATYPE *,long))Routine1);
	PLC_AddCommand("Routine2", (void (__cdecl *)(struct PLC_DATATYPE *,long))Routine2);

	return MessageBox(0, "Initialize", "", MB_YESNO) == IDYES;
}
